module CopPluginCache where

import State
import LegalMoves

data CopPluginCache = CopPluginCache {
    cpi_cache_legal_moves :: PlayerState -> [PlayerState],
    cpi_cache_legal_moves_same_state :: PlayerState -> [PlayerState],
    cpi_cache_legal_anti_moves :: PlayerState -> [PlayerState],

    cpi_cache_plot_course :: PlayerState -> Loc -> ([PlayerState], Distance),

    cpi_cache_states_up_to_distance :: StatesUpToDistanceFn,
    cpi_cache_states_at_distance :: StatesAtDistanceFn,
    cpi_cache_locs_up_to_distance :: LocsUpToDistanceFn,
    cpi_cache_locs_at_distance :: LocsAtDistanceFn,

    cpi_cache_states_up_to_distance_same_state :: StatesUpToDistanceFn,
    cpi_cache_states_at_distance_same_state :: StatesAtDistanceFn,
    cpi_cache_locs_up_to_distance_same_state :: LocsUpToDistanceFn,
    cpi_cache_locs_at_distance_same_state :: LocsAtDistanceFn
}
