module CopPluginLog where

import State

data CopPluginLog = CopPluginLog {
    cpi_log_skeleton :: WorldSkeleton,
    cpi_log_update :: WorldUpdate,
    cpi_log_sent_informs :: [Inform],
    cpi_log_received_informs :: [(PlayerName, [Maybe Inform])],
    cpi_log_sent_plans :: [Plan],
    cpi_log_received_plans :: [(PlayerName, [Maybe Plan])],
    cpi_log_vote :: [PlayerName],
    cpi_log_winner :: Winner,
    cpi_log_move :: CopMove
}
