module GraphUtil where

import Data.Graph.Inductive

repl_edges_to :: (DynGraph g) => g a b -> [(Node, b)] -> g a b
repl_edges_to g dst_costs =
    let (dels, adds) = unzip [((src,dst), (src,dst,cst))
                              | (dst,cst) <- dst_costs, src <- pre g dst]
    in  insEdges adds $ delEdges dels g
