module RobberPluginCache where

import State
import LegalMoves

data RobberPluginCache = RobberPluginCache {
    rpi_cache_legal_moves :: PlayerState -> [PlayerState],
    rpi_cache_legal_moves_same_state :: PlayerState -> [PlayerState],
    rpi_cache_legal_anti_moves :: PlayerState -> [PlayerState],

    rpi_cache_plot_course :: PlayerState -> Loc -> ([PlayerState], Distance),

    rpi_cache_states_up_to_distance :: StatesUpToDistanceFn,
    rpi_cache_states_at_distance :: StatesAtDistanceFn,
    rpi_cache_locs_up_to_distance :: LocsUpToDistanceFn,
    rpi_cache_locs_at_distance :: LocsAtDistanceFn,

    rpi_cache_states_up_to_distance_same_state :: StatesUpToDistanceFn,
    rpi_cache_states_at_distance_same_state :: StatesAtDistanceFn,
    rpi_cache_locs_up_to_distance_same_state :: LocsUpToDistanceFn,
    rpi_cache_locs_at_distance_same_state :: LocsAtDistanceFn
}
