module RobberProg where

import BotProg
import ProtocolRobber
import RobberStatue
import RobberAimless
import RobberFearless
import RobberHeuristic
import RobberJanosik
import RobberHermit
import RobberGamer

all_robbers :: AllBots
all_robbers =
    [
     ("statue", run_robber robber_statue),
     ("aimless", run_robber robber_aimless),
     ("fearless", run_robber robber_fearless),
     ("heuristic", run_robber robber_heuristic),
     ("janosik", run_robber (robber_janosik 10)),
     ("rumcajs", run_robber (robber_janosik 5)),
     ("hermit", run_robber robber_hermit),
     ("gamer", run_robber robber_gamer)
    ]

robber_prog :: BotName -> IO ()
robber_prog default_bot_name = bot_prog all_robbers default_bot_name
